;;File Name "Kim_WiringS.lsp"
;;Command Name "ws"
;;
;;Action "dCݔpSz"
;;
;;;;How to Use
;;(1)R}hC"ws"Ɠ͂AEnter
;;(2)<Start Point>.....ŏ̓_NbN
;;(3)<End Point>.......Ō̓_NbN
;;(4)<|C`悳>.....px45xɌŒ@
;;				  X,Y͎
;;					in_AI_̈ʒu֌Wɂj
;;				  px̃`FbN͂ĂȂ
;;					(n_AI_Ԓ̊px45xn{̎)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;startP(Xs,Ys)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;midPS(Xms,Yms)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;/
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;/
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; midPM(Xmm,Ymm)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;/
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;/
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;midPE(Xme,Yme)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;endP(Xe,Ye)
;;
;;Code Begin----------
;*****G[(lȊO̓́j
(defun *error* (msg)
	(princ msg)
	(princ)
)
(defun C:ws()
	;*****݂̃GeBeBXibv̐ݒޔ
	(setq oldES (getvar "OSMODE"))

	;*****V{pGeBeBXibvݒ
	(setvar "OSMODE" 58)
		;2(Midpoint) + 8(Point snap) + 16(Quadrant) + 32(Intersection)
	
	;*****n_AI_擾
	(setq startP (getpoint "\n<Start point>:"))
	(setq endP (getpoint "\n<End point>:"))

	;*****GeBeBXibv̐ݒ𕜋
	(setvar "OSMODE" oldES)

	;*****n_AI_̍W̌vZ
	(setq Xs (car startP))       ;n_XW
	(setq Ys (car (cdr startP))) ;n_YW
	(setq Xe (car endP))         ;I_XW
	(setq Ye (car (cdr endP)))   ;I_YW

	;*****n_AI_Ԓ̊px̌vZ
	(setq wireAng (angle startP endP))

	;*****45x̊pxɖO
	(setq Ang0 0)		  ;0	@ (0x)
	(setq Ang1 (* 1 (/ pi 4)));1/4 pi@(45x)
	(setq Ang2 (* 2 (/ pi 4)));2/4 pi  (90x)
	(setq Ang3 (* 3 (/ pi 4)));3/4 pi  (135x)
	(setq Ang4 (* 4 (/ pi 4)));4/4 pi  (180x)
	(setq Ang5 (* 5 (/ pi 4)));5/4 pi  (225x)
	(setq Ang6 (* 6 (/ pi 4)));6/4 pi  (270x)
	(setq Ang7 (* 7 (/ pi 4)));7/4 pi  (315x)
	(setq Ang8 (* 8 (/ pi 4)));8/4 pi@(360x)

	;*****n_ƏI_̈ʒu֌W̌vZ

	(cond
		((and (> wireAng Ang0) (< wireAng Ang1))	;0 -- 1/4 pi
			(setq XYD "x")	
		)
		((and (> wireAng Ang1) (< wireAng Ang2))	;1/4 pi -- 2/4 pi
			(setq XYD "y")
		)
		((and (> wireAng Ang2) (< wireAng Ang3))	;2/4 pi -- 3/4 pi
			(setq XYD "y")
		)
		((and (> wireAng Ang3) (< wireAng Ang4))	;3/4 pi -- 4/4 pi
			(setq XYD "x")
		)
		((and (> wireAng Ang4) (< wireAng Ang5))	;4/4 pi -- 5/4 pi
			(setq XYD "x")
		)
		((and (> wireAng Ang5) (< wireAng Ang6))	;5/4 pi -- 6/4 pi
			(setq XYD "y")
		)
		((and (> wireAng Ang6) (< wireAng Ang7))	;6/4 pi -- 7/4 pi
			(setq XYD "y")
		)
		((and (> wireAng Ang7) (< wireAng Ang8))	;7/4 pi -- 8/4 pi
			(setq XYD "x")
		)
	)
	
	;*****n_AI_Ԃ̋vZ
	(setq distS (distance startP endP))

	;*****n_ƏI_Ԓ̒_̍W̌vZ
	(setq midPM (polar startP wireAng  (/ distS 2))) 
	(setq Xmm (car midPM))       ;_XW
	(setq Ymm (car (cdr midPM))) ;_YW

	;*****ԓ_̍W̌vZ
	(cond
		((and(> Xe Xs)(> Ye Ys)(= XYD "x"));I_n_̏㑤 E X
			(setq Xms (- Xmm (- Ymm Ys)))(setq Yms Ys)
			(setq Xme (+ Xmm (- Ymm Ys)))(setq Yme Ye)
		)
		((and(> Xs Xe)(> Ye Ys)(= XYD "x"));I_n_̏㑤  X
			(setq Xms (+ Xmm (- Ymm Ys)))(setq Yms Ys)
			(setq Xme (- Xmm (- Ymm Ys)))(setq Yme Ye)
		)
		((and(> Xe Xs)(> Ys Ye)(= XYD "x"));I_n_̉ E X
			(setq Xms (- Xmm (- Ys Ymm)))(setq Yms Ys)
			(setq Xme (+ Xmm (- Ys Ymm)))(setq Yme Ye)
		)
		((and(> Xs Xe)(> Ys Ye)(= XYD "x"));I_n_̉  X
			(setq Xms (+ Xmm (- Ys Ymm)))(setq Yms Ys)
			(setq Xme (- Xmm (- Ys Ymm)))(setq Yme Ye)
		)

		((and(> Xe Xs)(> Ye Ys)(= XYD "y"));I_n_̏㑤 E Y
			(setq Yms (- Ymm (- Xmm Xs)))(setq Xms Xs)
			(setq Yme (+ Ymm (- Xmm Xs)))(setq Xme Xe)
		)
		((and(> Xs Xe)(> Ye Ys)(= XYD "y"));I_n_̏㑤  Y
			(setq Yms (+ Ymm (- Xmm Xs)))(setq Xms Xs)
			(setq Yme (- Ymm (- Xmm Xs)))(setq Xme Xe)
		)
		((and(> Xe Xs)(> Ys Ye)(= XYD "y"));I_n_̉ E Y
			(setq Yms (- Ymm (- Xs Xmm)))(setq Xms Xs)
			(setq Yme (+ Ymm (- Xs Xmm)))(setq Xme Xe)
		)
		((and(> Xs Xe)(> Ys Ye)(= XYD "y"));I_n_̉  Y
			(setq Yms (+ Ymm (- Xs Xmm)))(setq Xms Xs)
			(setq Yme (- Ymm (- Xs Xmm)))(setq Xme Xe)
		)

	)
	
	;*****ԓ_̃Xg쐬
	(setq midPS (list Xms Yms)) ;ԓ_S̃Xg
	(setq midPE (list Xme Yme)) ;ԓ_ẼXg

	;*****|C`
	(command "PLINE" startP midPS midPE endP "")
		;n_Aԓ_SAԓ_EAI_ʂ|C`

	;*****|CI
	(setq mypolyline(entlast))

	;*****|Cۂ߂
	(command "FILLET" "P" mypolyline);|Cۂ߂
	
)
;;Code End-------------
